<?php
/**
 * Local Supermarket functions and definitions
 * @package Local Supermarket
 */

if ( ! function_exists( 'local_supermarket_after_theme_support' ) ) :

	function local_supermarket_after_theme_support() {
		
		add_theme_support( 'automatic-feed-links' );

		add_theme_support(
			'custom-background',
			array(
				'default-color' => 'ffffff',
			)
		);

		$GLOBALS['content_width'] = apply_filters( 'local_supermarket_content_width', 1140 );
		
		add_theme_support( 'post-thumbnails' );

		add_theme_support(
			'custom-logo',
			array(
				'height'      => 270,
				'width'       => 90,
				'flex-height' => true,
				'flex-width'  => true,
			)
		);
		
		add_theme_support( 'title-tag' );

        load_theme_textdomain( 'local-supermarket', get_template_directory() . '/languages' );

		add_theme_support(
			'html5',
			array(
				'search-form',
				'comment-form',
				'comment-list',
				'gallery',
				'caption',
				'script',
				'style',
			)
		);

		add_theme_support( 'post-formats', array(
			'video',  
			'audio',  
			'gallery',
			'quote',  
			'image',  
			'link',   
			'status', 
			'aside',  
			'chat',   
		) );
		
		add_theme_support( 'align-wide' );
		add_theme_support( 'responsive-embeds' );
        add_theme_support( 'woocommerce' );
		add_theme_support( 'wp-block-styles' );

		require get_template_directory() . '/inc/metabox.php';
		require get_template_directory() . '/inc/homepage-setup/homepage-setup-settings.php';

		if (! defined( 'LOCAL_SUPERMARKET_BUY_NOW' ) ){
		define('LOCAL_SUPERMARKET_BUY_NOW',__('https://www.omegathemes.com/products/supermarket-wordpress-theme','local-supermarket'));
		}
		if (! defined( 'LOCAL_SUPERMARKET_SUPPORT_FREE' ) ){
		define('LOCAL_SUPERMARKET_SUPPORT_FREE',__('https://wordpress.org/support/theme/local-supermarket/','local-supermarket'));
		}
		if (! defined( 'LOCAL_SUPERMARKET_DEMO_PRO' ) ){
		define('LOCAL_SUPERMARKET_DEMO_PRO',__('https://layout.omegathemes.com/local-supermarket/','local-supermarket'));
		}
		if (! defined( 'LOCAL_SUPERMARKET_LITE_DOCS_PRO' ) ){
		define('LOCAL_SUPERMARKET_LITE_DOCS_PRO',__('https://layout.omegathemes.com/steps/local-supermarket/','local-supermarket'));
		}
		if (! defined('LOCAL_SUPERMARKET_BUNDLE_BUTTON') ){
			define('LOCAL_SUPERMARKET_BUNDLE_BUTTON',__('https://www.omegathemes.com/products/wp-theme-bundle','local-supermarket'));
		}
	}

endif;

add_action( 'after_setup_theme', 'local_supermarket_after_theme_support' );

/**
 * Register and Enqueue Styles.
 */
function local_supermarket_register_styles() {

	wp_enqueue_style( 'dashicons' );

    $local_supermarket_theme_version = wp_get_theme()->get( 'Version' );
	$local_supermarket_fonts_url = local_supermarket_fonts_url();
    if( $local_supermarket_fonts_url ){
    	require get_theme_file_path( 'lib/custom/css/wptt-webfont-loader.php' );
        wp_enqueue_style(
			'local-supermarket-google-fonts',
			wptt_get_webfont_url( $local_supermarket_fonts_url ),
			array(),
			$local_supermarket_theme_version
		);
    }
	wp_enqueue_style( 'local-supermarket-style', get_stylesheet_uri(), array(), $local_supermarket_theme_version );

	wp_enqueue_style( 'local-supermarket-style', get_stylesheet_uri() );
	require get_parent_theme_file_path( '/custom_css.php' );
	wp_add_inline_style( 'local-supermarket-style',$local_supermarket_custom_css );
	wp_enqueue_style(
		'fontawesome-css',
		get_template_directory_uri() . '/assets/css/fontawesome-all.css',
		array(),'4.5.0'
	);

	$local_supermarket_css = '';

	if ( get_header_image() ) :

		$local_supermarket_css .=  '
			.header-image-box{
				background-image: url('.esc_url(get_header_image()).') !important;
				-webkit-background-size: cover !important;
				-moz-background-size: cover !important;
				-o-background-size: cover !important;
				background-size: cover !important;
				height: 450px;
				display: flex;
				align-items: center;
			}';

	endif;

	wp_add_inline_style( 'local-supermarket-style', $local_supermarket_css );

	if ( is_singular() && comments_open() && get_option( 'thread_comments' ) ) {
		wp_enqueue_script( 'comment-reply' );
	}	

	wp_enqueue_script( 'imagesloaded' );
    wp_enqueue_script( 'masonry' );
	wp_enqueue_script( 'local-supermarket-custom', get_template_directory_uri() . '/lib/custom/js/theme-custom-script.js', array('jquery'), '', 1);
	wp_localize_script(
        'local-supermarket-custom',
        'ajax_obj',
        array(
            'ajaxurl' => admin_url('admin-ajax.php')
        )
    );
	wp_enqueue_script(
		'owl.carousel-js',
		esc_url(get_template_directory_uri()) . '/assets/js/owl.carousel.js',
		array(),
		true
	);
	wp_enqueue_style('owl-carousel-css',
		esc_url(get_template_directory_uri()) . '/assets/css/owl.carousel.css',
		array()
	);
	wp_enqueue_script(
		'jewelry-outlet-custom',
		get_template_directory_uri() . '/assets/js/custom.js',
		array('jquery'),
		'1.0',
		TRUE
	);

	wp_enqueue_style( 'bootstrap-style', get_template_directory_uri().'/assets/css/bootstrap.css', array(), $local_supermarket_theme_version );

    // Scripts
    wp_enqueue_script( 'bootstrap-js',
        get_template_directory_uri(). '/assets/js/bootstrap.js',
        array('jquery'),
        $local_supermarket_theme_version,
        true
    );

    // Global Query
    if( is_front_page() ){

    	$local_supermarket_posts_per_page = absint( get_option('posts_per_page') );
        $local_supermarket_c_paged = ( get_query_var( 'page' ) ) ? absint( get_query_var( 'page' ) ) : 1;
        $local_supermarket_posts_args = array(
            'posts_per_page'        => $local_supermarket_posts_per_page,
            'paged'                 => $local_supermarket_c_paged,
        );
        $posts_qry = new WP_Query( $local_supermarket_posts_args );
        $max = $posts_qry->max_num_pages;

    }else{
        global $wp_query;
        $max = $wp_query->max_num_pages;
        $local_supermarket_c_paged = ( get_query_var( 'paged' ) > 1 ) ? get_query_var( 'paged' ) : 1;
    }

    $local_supermarket_default = local_supermarket_get_default_theme_options();
    $local_supermarket_pagination_layout = get_theme_mod( 'local_supermarket_pagination_layout',$local_supermarket_default['local_supermarket_pagination_layout'] );
}

add_action( 'wp_enqueue_scripts', 'local_supermarket_register_styles',200 );

function local_supermarket_admin_enqueue_scripts_callback() {
    if ( ! did_action( 'wp_enqueue_media' ) ) {
    wp_enqueue_media();
    }
    wp_enqueue_script('local-supermarket-uploaderjs', get_stylesheet_directory_uri() . '/lib/custom/js/uploader.js', array(), "1.0", true);
}
add_action( 'admin_enqueue_scripts', 'local_supermarket_admin_enqueue_scripts_callback' );

/**
 * Register navigation menus uses wp_nav_menu in five places.
 */

function local_supermarket_menus() {

	$local_supermarket_locations = array(
		'local-supermarket-primary-menu'  => esc_html__( 'Primary Menu', 'local-supermarket' ),
	);

	register_nav_menus( $local_supermarket_locations );
}

add_action( 'init', 'local_supermarket_menus' );

add_filter('loop_shop_columns', 'local_supermarket_loop_columns');
if (!function_exists('local_supermarket_loop_columns')) {
	function local_supermarket_loop_columns() {
		$local_supermarket_columns = get_theme_mod( 'local_supermarket_per_columns', 3 );
		return $local_supermarket_columns;
	}
}

add_filter( 'loop_shop_per_page', 'local_supermarket_per_page', 20 );
function local_supermarket_per_page( $local_supermarket_cols ) {
  	$local_supermarket_cols = get_theme_mod( 'local_supermarket_product_per_page', 9 );
	return $local_supermarket_cols;
}

function local_supermarket_products_args( $local_supermarket_args ) {

    $local_supermarket_args['posts_per_page'] = get_theme_mod( 'local_supermarket_custom_related_products_number', 6 );

    $local_supermarket_args['columns'] = get_theme_mod( 'local_supermarket_custom_related_products_number_per_row', 3 );

    return $local_supermarket_args;
}

require get_template_directory() . '/inc/custom-header.php';
require get_template_directory() . '/classes/class-svg-icons.php';
require get_template_directory() . '/classes/class-walker-menu.php';
require get_template_directory() . '/inc/customizer/customizer.php';
require get_template_directory() . '/inc/custom-functions.php';
require get_template_directory() . '/inc/template-tags.php';
require get_template_directory() . '/classes/body-classes.php';
require get_template_directory() . '/inc/widgets/widgets.php';
require get_template_directory() . '/inc/pagination.php';
require get_template_directory() . '/lib/breadcrumbs/breadcrumbs.php';
require get_template_directory() . '/lib/custom/css/dynamic-style.php';
require get_template_directory() . '/inc/general.php';
require get_template_directory() . '/inc/homepage-setup/whizzie.php';

function local_supermarket_remove_customize_register() {
    global $wp_customize;
    $wp_customize->remove_setting( 'display_header_text' );
    $wp_customize->remove_control( 'display_header_text' );

}

add_action( 'customize_register', 'local_supermarket_remove_customize_register', 11 );

function local_supermarket_radio_sanitize(  $local_supermarket_input, $local_supermarket_setting  ) {
	$local_supermarket_input = sanitize_key( $local_supermarket_input );
	$local_supermarket_choices = $local_supermarket_setting->manager->get_control( $local_supermarket_setting->id )->choices;
	return ( array_key_exists( $local_supermarket_input, $local_supermarket_choices ) ? $local_supermarket_input : $local_supermarket_setting->default );
}

// NOTICE FUNCTION

function local_supermarket_admin_notice() { 
    global $pagenow;
    $theme_args = wp_get_theme();
    $meta = get_option( 'local_supermarket_admin_notice' );
    $name = $theme_args->get( 'Name' );
    $current_screen = get_current_screen();

    if ( ! $meta ) {
        if ( is_network_admin() ) {
            return;
        }

        if ( ! current_user_can( 'manage_options' ) ) {
            return;
        }

        if ( $current_screen->base != 'appearance_page_localsupermarket-wizard' ) {
            ?>
            <div class="notice notice-success notice-content">
                <h2><?php esc_html_e('Welcome! Thank you for choosing Local Supermarket. Let’s Set Up Your Website!', 'local-supermarket') ?> </h2>
                <p><?php esc_html_e('Before you dive into customization, let’s go through a quick setup process to ensure everything runs smoothly. Click below to start setting up your website in minutes!', 'local-supermarket') ?> </p>
                <div class="info-link">
                    <a href="<?php echo esc_url( admin_url( 'themes.php?page=localsupermarket-wizard' ) ); ?>"><?php esc_html_e('Get Started with Local Supermarket', 'local-supermarket'); ?></a>
					<a href="#" class="notice-bundle" id="bundleTrigger"><?php esc_html_e('Get All WP Themes', 'local-supermarket'); ?></a>
					<div class="bundle-overlay" id="bundlePopup">
						<div class="bundle-modal">
							<span class="close-popup">&times;</span>
							<div class="sale-badge"><?php esc_html_e('🔥 MEGA SALE', 'local-supermarket'); ?></div>
							<h2><?php esc_html_e('Unlock All Premium WP Themes', 'local-supermarket'); ?></h2>
							<p> <?php esc_html_e('Unlock the Full Potential of Your Website with Our 50+ WordPress Themes Bundle', 'local-supermarket'); ?></p>
							<ul>
								<li><?php esc_html_e('✔ Expert Support', 'local-supermarket'); ?></li>
								<li><?php esc_html_e('✔ Premium Theme ZIP File', 'local-supermarket'); ?></li>
								<li><?php esc_html_e('✔ Ready-to-Use Website Templates', 'local-supermarket'); ?></li>
								<li><?php esc_html_e('✔ Demo Content (Included in the file)', 'local-supermarket'); ?></li>
								<li><?php esc_html_e('✔ Access to the Premium Support Forum', 'local-supermarket'); ?></li>
							</ul>
							<a href="<?php echo esc_url( LOCAL_SUPERMARKET_BUNDLE_BUTTON ); ?>" target="_blank" class="bundle-cta"><?php esc_html_e('Get the Bundle Now →', 'local-supermarket'); ?></a>
						</div>
					</div>
                </div>
                <p class="dismiss-link"><strong><a href="?local_supermarket_admin_notice=1"><?php esc_html_e( 'Dismiss', 'local-supermarket' ); ?></a></strong></p>
            </div>
            <?php
        }
    }
}
add_action( 'admin_notices', 'local_supermarket_admin_notice' );

if ( ! function_exists( 'local_supermarket_update_admin_notice' ) ) :
/**
 * Updating admin notice on dismiss
 */
function local_supermarket_update_admin_notice() {
    if ( isset( $_GET['local_supermarket_admin_notice'] ) && $_GET['local_supermarket_admin_notice'] == '1' ) {
        update_option( 'local_supermarket_admin_notice', true );
    }
}
endif;
add_action( 'admin_init', 'local_supermarket_update_admin_notice' );

add_action( 'wp_ajax_get_product_rating', 'local_supermarket_get_product_rating' );
add_action( 'wp_ajax_nopriv_get_product_rating', 'local_supermarket_get_product_rating' );

function local_supermarket_get_product_rating() {
    if ( ! isset($_POST['product_id']) ) {
        wp_send_json_error( [ 'message' => 'No product ID given' ] );
    }

    $product_id = intval( $_POST['product_id'] );
    $product    = wc_get_product( $product_id );

    if ( ! $product ) {
        wp_send_json_error( [ 'message' => 'Invalid product' ] );
    }

    $average      = $product->get_average_rating();
    $review_count = $product->get_review_count();

    wp_send_json_success( [
        'average'      => $average,
        'review_count' => $review_count,
    ] );
}

add_filter( 'woocommerce_enable_setup_wizard', '__return_false' );

add_action( 'init', function() {
    update_option( 'elementor_onboard_wizard_completed', 'yes' );
});